@use './styles/calendar.variables' as *;
@use './../../../global/styles/utilities' as *;

:host {
  @include digi-calendar--variables;

  .digi-calendar {
    display: var(--digi--calendar--display);
    background: var(--digi--calendar--header--button--background);
    padding: 0px 1px 3px 1px;
    overflow: hidden;
    &--hide {
      --digi--calendar--display: none;
    }
  }

  .digi-calendar__header {
    display: var(--digi--calendar--header--display);
    align-items: var(--digi--calendar--header--align-items);
    justify-content: var(--digi--calendar--header--justify-content);
    text-align: var(--digi--calendar--header--text-align);
    font-size: var(--digi--global--typography--font-size--base);
    font-family: var(--digi--calendar--header--font-family);
    font-weight: var(--digi--calendar--header--font-weight);
    &--year-select {
      display: inherit;
      justify-content: center;
      margin: 0 auto;
      :first-child {
        margin-right: var(--digi--padding--smaller);
      }
      :last-child {
        width: 5rem;
      }
    }
    &--month-step {
      flex: auto;
      display: inherit;
      align-items: inherit;
      justify-content: inherit;
      .digi-calendar__month-select-name {
        padding-inline: var(--digi--padding--smaller);
      }
      .digi-calendar__month-select-button {
        font-family: inherit;
        font-size: inherit;
        font-weight: inherit;
        color: var(--digi--calendar--date--color);
        display: flex;
        align-items: center;
        background: var(--digi--calendar--header--button--background);
        border: var(--digi--calendar--date--box-shadow);
        padding: var(--digi--calendar--header--button--padding);
        &:last-child {
          border-radius: 0 4px 0 0;
        }
        &:first-child {
          border-radius: 4px 0 0 0;
        }
        &:focus,
        &:hover {
          --digi--calendar--header--button--background: var(
            --digi--calendar--header--button--background--hover
          );
          text-decoration: underline;
          cursor: pointer;
        }
        &:focus-visible{
          @include digi--focus--inset();
        }
      }
    }
  }

  .digi-calendar__table {
    border-collapse: var(--digi--calendar--table--border-collapse);
    border-spacing: var(--digi--calendar--table--border-spacing);
    font-family: var(--digi--calendar--table--font-family);
    table-layout: fixed;
    margin-bottom: var(--digi--margin--medium);
  }

  .digi-calendar__table-header-week {
    font-style: italic;
    padding: var(--digi--calendar--table-header--padding);
    font-weight: var(--digi--calendar--table-header--font-weight-normal);
    width: 50px;
  }

  .digi-calendar__table-header {
    padding: var(--digi--calendar--table-header--padding);
    font-weight: var(--digi--calendar--table--font-weight);
    width: 46px;
  }

  .digi-calendar__td-week {
    border-right: var(--digi--calendar--week--border-width) solid
      var(--digi--calendar--week--border-color);
  }

  .digi-calendar__date--week-number {
    font-style: var(--digi--calendar--week--font-style);
    font-size: var(--digi--calendar--week--font-size);
    display: table-cell;
    text-align: center;
    &:hover {
      cursor: default;
    }
  }

  .digi-calendar__date {
    position: relative;
    padding: var(--digi--calendar--date--padding);
    color: var(--digi--calendar--date--color);
    background-color: var(--digi--calendar--date--background-color);
    border-color: var(--digi--calendar--date--border-color);
    border-radius: var(--digi--border-radius--secondary);
    font-family: inherit;
    font-size: inherit;
    font-weight: inherit;
    text-align: center;
    border: none;
    width: 44px;
    height: 44px;

    &--disabled {
      --digi--calendar--date--color: transparent;
      pointer-events: none;
    }

    &--today {
      position: relative;
      &::after {
        display: block;
        content: ' ';
        position: absolute;
        top: var(--digi--calendar--date--today--circle-margin);
        bottom: var(--digi--calendar--date--today--circle-margin);
        left: var(--digi--calendar--date--today--circle-margin);
        right: var(--digi--calendar--date--today--circle-margin);
        border: var(--digi--calendar--date--today--circle-border);
        border-radius: 50%;
      }
    }
    &:hover {
      --digi--calendar--date--box-shadow: var(
        --digi--calendar--date--box-shadow--hover
      );
      --digi--calendar--date--background-color: var(
        --digi--calendar--date--background-color--hover
      );
      cursor: pointer;

      span {
        text-decoration: underline;
      }
    }

    &--selected {
      --digi--calendar--date--background-color: var(
        --digi--calendar--date--selected--background-color
      );
      --digi--calendar--date--color: var(
        --digi--calendar--date--selected--color
      );

      &:hover {
        --digi--calendar--date--background-color: var(
          --digi--calendar--date--selected--background-color
        );

        span {
          text-decoration: none;
        }
      }
      &:focus-visible{
        @include digi--focus--inset();
      }
    }
    &--not-selectable::after {
      display: block;
      content: ' ';
      width: 0px;
      height: 100%;
      border: 1px solid #757575;
      transform: rotate(-45deg);
      position: absolute;
      top: 0%;
      left: 50%;
    }

    &--focused:focus-visible:not(.digi-calendar__date--selected) {
      --digi--calendar--date--background-color: var(
        --digi--calendar--date--focused--background-color
      );
      @include digi--focus--inset();
    }
  }
}

::slotted(* digi-form-label) {
  @include digi--a11y--sr-only;
}
